//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de/frida
//**************************************************************************************************

//! \file  calc.cpp
//! \brief NCalc::Calculator: the command-line pocket calculator.


#include <memory>
#include <string>
#include <vector>
#include <map>
#include <cstdio>

using namespace std;

#include "defs.hpp"
#include "olf.hpp"
#include "mem.hpp"
#include "reg.hpp"
#include "obj.hpp"
#include "expr.hpp"
#include "calc.hpp"
#include "xax_lex.hpp"


//! Evaluates one expression and displays result.

void NCalc::calculator( string expr )
{
    // cout << "computing '" << s << "'\n";
    PNode T = user_xaxparse( expr.c_str() );
    if( T->has_dummy() )
        throw "dummy argument t not allowed outside curve definitions";
    NOlm::IterateO fiter( NOlm::IterTOL );
    if( fiter.size()==0 || !T->k_dependent() ) {
        RObj ret = T->tree_point_val();
        if( !CNode::eval( "defined (\"$silent\")" )->to_b() && ret->to_s() != "__NULL__" )
            cout << ret->to_s() << "\n";
    } else {
        while ( (fiter()) ) {
            int k = fiter.k();
            if ( fiter.size()>1 )
                cout << "f" << k <<":";
            cout << T->tree_point_val( k )->to_s() << "\n";
        }
    }
//  TODO: resuscitate NReg::lastresult = ret (aka $_);
}