//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-
//*  http://apps.jcns.fz-juelich.de
//**************************************************************************************************

//! \file  manip.hpp
//! \brief NManip: manipulate data (select, bin, sort, ...)

//! Manipulate data (select, bin, sort, ...)

namespace NManip {
    void freeze_slice( bool on );
    void points_select( bool sel_del );
    void points_rebin();
    void points_rebin_by_factor();
    void points_rebin_by_err( const string& subcmd );
    void points_rebin_duplicates();
    void points_sort();
    void points_symmetrize();
    void slices_select( bool sel_del );
    void slices_rebin();
    void slices_merge();
    void slices_break();
    void slices_spawn();
    void zcoords_reorder();
    void zcoord_delete();
    void slices_sort();
    void slices_sort_by_z();
    void exchange_x_z();
    void make_histogram();
    void files_merge( const string& opts );
    void files_merge_pointwise();
    void interpolate();
}